
-- VHDL Test Bench Created from source file dlabdio5.vhd -- 10:17:43 03/20/2003
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT dlabdio5
	PORT(
		adr : IN std_logic_vector(5 downto 0);
		clk : IN std_logic;
		cs : IN std_logic;
		we : IN std_logic;
		oe : IN std_logic;
		lcen : IN std_logic;
		rgbBtnIn : IN std_logic_vector(15 downto 0);
		rgbSwt : IN std_logic_vector(7 downto 0);
		kbck : IN std_logic;
		kbdk : IN std_logic;    
		db : INOUT std_logic_vector(7 downto 0);
		rgbLcd : INOUT std_logic_vector(7 downto 0);      
		lcden : OUT std_logic;
		lcdrw : OUT std_logic;
		lcdrs : OUT std_logic;
		encBtn : OUT std_logic_vector(3 downto 0);
		rgbBtnOt : OUT std_logic_vector(5 downto 0);
		rgbLed : OUT std_logic_vector(15 downto 0);
		rgbSsgAn : OUT std_logic_vector(3 downto 0);
		rgbSsgCa : OUT std_logic_vector(7 downto 0);
		kbcs : OUT std_logic;
		kbds : OUT std_logic
		);
	END COMPONENT;

	constant	period : time := 4 us;

	SIGNAL db :  std_logic_vector(7 downto 0);
	SIGNAL adr :  std_logic_vector(5 downto 0);
	SIGNAL clk :  std_logic;
	SIGNAL cs :  std_logic;
	SIGNAL we :  std_logic;
	SIGNAL oe :  std_logic;
	SIGNAL lcen :  std_logic;
	SIGNAL rgbLcd :  std_logic_vector(7 downto 0);
	SIGNAL lcden :  std_logic;
	SIGNAL lcdrw :  std_logic;
	SIGNAL lcdrs :  std_logic;
	SIGNAL rgbBtnIn :  std_logic_vector(15 downto 0);
	SIGNAL encBtn :  std_logic_vector(3 downto 0);
	SIGNAL rgbBtnOt :  std_logic_vector(5 downto 0);
	SIGNAL rgbLed :  std_logic_vector(15 downto 0);
	SIGNAL rgbSsgAn :  std_logic_vector(3 downto 0);
	SIGNAL rgbSsgCa :  std_logic_vector(7 downto 0);
	SIGNAL rgbSwt :  std_logic_vector(7 downto 0);
	SIGNAL kbcs :  std_logic;
	SIGNAL kbds :  std_logic;
	SIGNAL kbck :  std_logic;
	SIGNAL kbdk :  std_logic;

BEGIN

	uut: dlabdio5 PORT MAP(
		db => db,
		adr => adr,
		clk => clk,
		cs => cs,
		we => we,
		oe => oe,
		lcen => lcen,
		rgbLcd => rgbLcd,
		lcden => lcden,
		lcdrw => lcdrw,
		lcdrs => lcdrs,
		rgbBtnIn => rgbBtnIn,
		encBtn => encBtn,
		rgbBtnOt => rgbBtnOt,
		rgbLed => rgbLed,
		rgbSsgAn => rgbSsgAn,
		rgbSsgCa => rgbSsgCa,
		rgbSwt => rgbSwt,
		kbcs => kbcs,
		kbds => kbds,
		kbck => kbck,
		kbdk => kbdk
	);


-- *** Test Bench - User Defined Section ***
clkgen: process
	begin
		clk <= '1' after period/2, '0' after period;
		wait until clk = '0';
	end process;

tb: PROCESS
   BEGIN

    -- Set initial state of all inputs to the CPLD
    cs <= '1';
    we <= '1';
    oe <= '1';
    adr <= "000000";
    db <= "11111111";
    lcen <= '0';
    rgbBtnIn <= "0000000000000000";
    rgbSwt <= "00000000";
    kbck <= '1';
    kbdk <= '1';

    wait for 10 us;

    -- Write a test pattern to the low byte of LED register
    adr <= "000011";
    db <= "10101010";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    we <= '0';
    wait for 200 ns;
    we <= '1';
    cs <= '1';
    db <= "ZZZZZZZZ";
    wait for 200 ns;

    -- Write a test pattern to the high byte of LED register
    adr <= "000100";
    db <= "01010101";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    we <= '0';
    wait for 200 ns;
    we <= '1';
    cs <= '1';
    db <= "ZZZZZZZZ";
    wait for 200 ns;

    -- Write a test pattern to the low byte of SSG register
    adr <= "000101";
    db <= "10101011";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    we <= '0';
    wait for 200 ns;
    we <= '1';
    cs <= '1';
    db <= "ZZZZZZZZ";
    wait for 200 ns;

    -- Write a test pattern to the high byte of SSG register
    adr <= "000110";
    db <= "11001101";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    we <= '0';
    wait for 200 ns;
    we <= '1';
    cs <= '1';
    db <= "ZZZZZZZZ";
    wait for 200 ns;

    -- Wait long enough for a clock edge to have caused data to
    -- be latched into the button register


    wait for 4*period;

    -- Read a value from the low byte of the buttons
    adr <= "000111";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    oe <= '0';
    wait for 200 ns;
    oe <= '1';
    cs <= '1';
    wait for 200 ns;

    -- read a value from the high byte of the buttons
    adr <= "001000";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    oe <= '0';
    wait for 200 ns;
    oe <= '1';
    cs <= '1';
    wait for 200 ns;

    -- Set a new value into the button inputs and then wait for it
    -- to be latched

    rgbBtnIn <= "0101010110101010";
    wait for 4*period;

    -- Read a value from the low byte of the buttons
    adr <= "000111";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    oe <= '0';
    wait for 200 ns;
    oe <= '1';
    cs <= '1';
    wait for 200 ns;

    -- read a value from the high byte of the buttons
    adr <= "001000";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    oe <= '0';
    wait for 200 ns;
    oe <= '1';
    cs <= '1';
    wait for 200 ns;

    -- read a value from the swtiches
    adr <= "001001";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    oe <= '0';
    wait for 200 ns;
    oe <= '1';
    cs <= '1';
    wait for 200 ns;

    rgbSwt <= "01101001";

    adr <= "001001";
    wait for 1 us;
    cs <= '0';
    wait for 200 ns;
    oe <= '0';
    wait for 200 ns;
    oe <= '1';
    cs <= '1';
    wait for 200 ns;


      wait; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
